#ifndef _BBCENTITYCLUSTER_H
#define _BBCENTITYCLUSTER_H

#include <BBCPrerequisites.h>
#include <BBCEntity.h>
#include <BBCEntityClusterData.h>
#include <BBCEntityDistribution.h>

#include <vector>

namespace BBC {

class _BBCExport EntityCluster {
  public:
    EntityCluster();

    ~EntityCluster();

	EntityClusterData* getEntityClusterData(unsigned int value);

	void addEntityClusterData(EntityClusterData *value);

	void removeEntitClusterData(unsigned int value);

	EntityDistribution* getEntityDistribution();

	void setEntityDistribution(EntityDistribution *value);

  protected:

	EntityDistribution *mEntityDistribution;
	
	std::vector<EntityClusterData*> mEntityClusterDataList;
    
	std::vector<unsigned int> mBillboarHandle;

	Entity *mEntity;

	unsigned int mBillboardHandle;

  public:

	Entity* getEntity();

	void setEntity(Entity* value);

	unsigned int getNumEntitiesClusterData();

    unsigned int getBillboardHandle();

    void setBillboardHandle(unsigned int value);

    void generateEntityCluster(); 

};

}
#endif
