#ifndef _IMGNODEBSP_H
#define _IMGNODEBSP_H

#include "IMGPrerequisites.h"
#include "IMGBox2d.h"

namespace IMG {

class NodeBsp {
  public:
    NodeBsp();

    Box2d * GetBound();

    inline void SetBound(Box2d * box) { bound = box; };

    inline NodeBsp * GetChild(int i) { return child[i]; };

    inline void SetId(int id_) { id = id_; };

    inline unsigned int GetId() const { return id; };

    inline void SetChild(NodeBsp * node, int i) { child[i] = node; };

    void Print();

    //void SetPlane (Plane3 *pla) { plane = pla; }
    //Plane3 * GetPlane () { return plane; }
    NodeBsp * Insert(int w, int h);

    inline NodeBsp * Get(NodeBsp * node, int i) {
    		if (!node) return NULL;
    		if (node->GetId() == i ) return node;
    		
    		NodeBsp *nod; 
    		if (nod = node->GetChild(0)->Get (node->GetChild(0), i)) return nod;
    		
    		return node->GetChild(0)->Get (node->GetChild(1), i);
    		
    	};


  private:
    bool fit;

    Box2d * bound;

    NodeBsp * child[2];

    static unsigned int ID;

    int id;


  public:
    ~NodeBsp();

};

}
#endif
