#ifndef _LBBCKMEANSCLUSTERGENERATOR_H
#define _LBBCKMEANSCLUSTERGENERATOR_H


#include <BBC.h>

namespace LBBC {

class _BBCExport KMeansClusterGenerator : public BBC::BillboardCloudGenerator {
  public:
    void generate();

    void init();

    KMeansClusterGenerator();

    ~KMeansClusterGenerator();

  protected:

	class Cell
	{
		protected:
		Cell *right;
		Cell *left;
		Ogre::Vector4 min;
		Ogre::Vector4 max;
		
		public:
		Cell()
		{
			right = NULL;
			left = NULL;
		}

		void setLeftChild(Cell *lChild)
		{
			left = lChild;
		}

		void setRightChild(Cell *rChild)
		{
			right = rChild;
		}

		Cell* getRightChild()
		{
			return right;
		}
		
		Cell* getLeftChild()
		{
			return left;
		}
		
		Ogre::Vector4 getMin()
		{
			return min;
		}
		
		Ogre::Vector4 getMax()
		{
			return max;
		}	

		void setMax(Ogre::Vector4 vmax)
		{
			max = vmax;
		}

		void setMin(Ogre::Vector4 vmin)
		{
			min = vmin;
		}
	};

};

}
#endif
